﻿/*
 * Sample from www.WayneCliffordBarker.co.za
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CleintVersion1
{
    class Program
    {
        static void Main(string[] args)
        {
            ConsoleKey key = ConsoleKey.B;
            printInstructions();

            do
            {
                if (key == ConsoleKey.A)
                {
                    Console.Clear();
                    printInstructions();
                    alterDataContract();
                }
                else
                {
                    if (key == ConsoleKey.S)
                    {
                        Console.Clear();
                        printInstructions();
                        submitDataContract();
                    }
                    else
                    {
                        if (key == ConsoleKey.R)
                        {
                            Console.Clear();
                            printInstructions();
                            receiveDataContract();
                        }
                        else
                        {
                            Console.Clear();
                            printInstructions();
                        }
                    }
                }
                key = Console.ReadKey().Key;
            }
            while (key != ConsoleKey.Q);
        }

        private static void printInstructions()
        {
            Console.ForegroundColor = ConsoleColor.Yellow;
            Console.WriteLine("Client Version 1");
            Console.WriteLine("Press 'Q' to quit.");
            Console.WriteLine("Press 'A' to read datacontract from service and resubmit it.");
            Console.WriteLine("Press 'R' to read datacontract from service.");
            Console.WriteLine("Press 'S' to submit data contract.");
            Console.WriteLine("");
            Console.ForegroundColor = ConsoleColor.White;
        }

        private static void submitDataContract()
        {
            Version1.Service1Client version1Client = new Version1.Service1Client();
            Version1.CompositeType composite = new Version1.CompositeType();

            composite.ClientVersion = 1;
            composite.RequiredField = "1234";
            composite.Version1FieldMemberToDelete = "to be deleted (V1)";

            Console.WriteLine("");
            Console.WriteLine("DATA SUBMITTED----------------------------------------------------------");
            Console.WriteLine(string.Format("Submitted by Client Version : {0}", composite.ClientVersion));
            Console.WriteLine(string.Format("Required Field : {0}", composite.RequiredField));
            Console.WriteLine(string.Format("Version1FieldMemberToDelete : {0}", composite.Version1FieldMemberToDelete));
            Console.WriteLine("------------------------------------------------------------------------");

            version1Client.SetDataUsingDataContractAsync(composite);
        }

        private static void receiveDataContract()
        {
            Version1.Service1Client version1Client = new Version1.Service1Client();
            Version1.CompositeType composite  = version1Client.GetDataUsingDataContract();

            if (composite != null)
            {
                Console.WriteLine("");
                Console.WriteLine("DATA RECEIVED-----------------------------------------------------------");
                Console.WriteLine(string.Format("Submitted by Client Version : {0}", composite.ClientVersion));
                Console.WriteLine(string.Format("Required Field : {0}", composite.RequiredField));
                Console.WriteLine(string.Format("Version1FieldMemberToDelete : {0}", composite.Version1FieldMemberToDelete));
                Console.WriteLine("------------------------------------------------------------------------");
            }
            else
            {
                Console.WriteLine("No Data");
            }
        }

        private static void alterDataContract()
        {
            Version1.Service1Client version1Client = new Version1.Service1Client();
            Version1.CompositeType composite = version1Client.GetDataUsingDataContract();

            if (composite != null)
            {
                Console.WriteLine("");
                Console.WriteLine("DATA RECEIVED-----------------------------------------------------------");
                Console.WriteLine(string.Format("Submitted by Client Version : {0}", composite.ClientVersion));
                Console.WriteLine(string.Format("Required Field : {0}", composite.RequiredField));
                Console.WriteLine(string.Format("Version1FieldMemberToDelete : {0}", composite.Version1FieldMemberToDelete));
                Console.WriteLine("------------------------------------------------------------------------");

                composite.ClientVersion = 1;
                version1Client.SetDataUsingDataContractAsync(composite);

                Console.WriteLine("");
                Console.WriteLine("DATA SUBMITTED----------------------------------------------------------");
                Console.WriteLine(string.Format("Submitted by Client Version : {0}", composite.ClientVersion));
                Console.WriteLine(string.Format("Required Field : {0}", composite.RequiredField));
                Console.WriteLine(string.Format("Version1FieldMemberToDelete : {0}", composite.Version1FieldMemberToDelete));
                Console.WriteLine("------------------------------------------------------------------------");
            }
            else
            {
                Console.WriteLine("No Data");
            }
        }
    }
}
